﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SprawdzanieNumeryPesel.ModelWidoku
{
    public class SprawdzanieNumeruPesel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        public void onPropertyChanged()
        {
            if(PropertyChanged!=null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(nameof(Poprawny)));
                PropertyChanged(this, new PropertyChangedEventArgs(nameof(DataUrodzenia)));
                PropertyChanged(this, new PropertyChangedEventArgs(nameof(NumerSeryjny)));
                PropertyChanged(this, new PropertyChangedEventArgs(nameof(Płeć)));
            }
        }

        private Model.Pesel model = new Model.Pesel();

        public string NumerPesel
        {
            set
            {
                model.ParsujNumerPesel(value);
                onPropertyChanged();
            }
            get
            {
                return model.NumerPesel;
            }
        }

        public bool Poprawny
        {
            get
            {
                return model.Poprawny;
            }
        }

        public string DataUrodzenia
        {
            get
            {
                if (model.DataUrodzenia.HasValue)
                    return model.DataUrodzenia.Value.ToLongDateString();
                else return "-";
            }
        }

        public string NumerSeryjny
        {
            get
            {
                if (model.NumerSeryjny.HasValue)
                    return model.NumerSeryjny.Value.ToString();
                else return "-";
            }
        }

        public string Płeć
        {
            get
            {
                return model.Płeć.ToString();
            }
        }

        public Func<string, bool> Warunek { get => (string pesel) => { return Model.Pesel.SprawdźNumerPesel(pesel); }; }
    }
}
